import { Component, TemplateRef, ViewChild } from '@angular/core';
import { ApproveTransactionService } from '../approve-transaction.service';
import { AuthService } from '../services/auth.service';
import { BsModalRef, BsModalService } from 'ngx-bootstrap/modal';

@Component({
  selector: 'app-approve-transaction',
  templateUrl: './approve-transaction.component.html',
  styleUrls: ['./approve-transaction.component.css'],
})
export class ApproveTransactionComponent {
  @ViewChild('viewTransactionReceipt') viewTransactionReceiptModal;
  bsTransactionReceiptModalRef: BsModalRef;
  constructor(
    private ApproveTransactionSvc: ApproveTransactionService,
    private modalService: BsModalService,
    private authSvc: AuthService
  ) {}

  selectedSearchOption: any = 1;
  fromDate: string = '';
  toDate: string = '';
  remitterFirstName: string = '';
  remitterLastName: string = '';
  benefFirstName: string = '';
  benefLastName: string = '';
  TransferTypeDropdown: any;
  transactionNumber: string = '';
  viewLastDropdown: any = 10;
  sendCountryDropdown: any;
  AgentID: any = 0;
  sendCurrencyDropdown: any = [];
  receiveCountryDropdown: any = -1;
  receiveCurrencyDropdown: any = -1;
  AgentDropdown: any;
  StatusDropdown: any;
  AgentBranchDropdown: any;
  UserDropdown: any;
  allData: any = [];
  sendCurrencyID: any = -1;
  payOutCountryID: any = -1;
  AgentBranchID: any = -1;
  StatusID: any = -1;
  ReceiveCountryID: any = -1;
  ReceiveCurrencyID: any = -1;
  TransferTypeID: any = -1;
  isLoading: boolean = false;
  receiptData: any = {};

  ngOnInit(): void {
    this.getSendCountry();
    this.getStatus();
    this.fromDate = this.authSvc.getTodayDate();
    this.toDate = this.authSvc.getTodayDate();
  }

  onSelectSearchbyType(item) {
    item;
  }

  onSelectView(item) {
    this.viewLastDropdown = item;
  }

  getStatus(AgentID: any = 0) {
    this.isLoading = true;

    this.ApproveTransactionSvc.getStatus(AgentID, -1).subscribe((res) => {
      this.StatusDropdown = res;
      this.isLoading = false;
    });
  }

  onSelectStatus(StatusID) {
    this.StatusID = StatusID;
  }

  view(item) {
    this.ApproveTransactionSvc.view(item).subscribe((res: any) => {
      if (res?.[0]?.IsDuplicate == true) {
        alert('No data found.');
        return;
      }
      this.receiptData = res?.[0];
      this.openTransactionReceiptModal(this.viewTransactionReceiptModal);
    });
  }

  getSendCountry() {
    this.ApproveTransactionSvc.getSendCountry().subscribe((res) => {
      this.sendCountryDropdown = res;
    });
  }

  onSelectSendCountry(CountryID) {
    this.payOutCountryID = CountryID;
    this.getSendCurrency(CountryID);
    this.getReceiveCountry(CountryID);
    this.getAgent(CountryID);
  }

  getSendCurrency(CountryId: any) {
    this.ApproveTransactionSvc.getSendCurrency(CountryId).subscribe((res) => {
      this.sendCurrencyDropdown = res;
    });
  }

  onSelectSendCurrency(sendCurrencyID) {
    this.sendCurrencyID = sendCurrencyID;
  }

  getReceiveCountry(CountryID: any) {
    this.ApproveTransactionSvc.getReceiveCountry(CountryID).subscribe((res) => {
      this.receiveCountryDropdown = res;
    });
  }

  onSelectReceiveCountry(ReceiveCountryID) {
    this.ReceiveCountryID = ReceiveCountryID;
    this.getReceiveCurrency(ReceiveCountryID);
  }

  getReceiveCurrency(CountryId: any) {
    this.ApproveTransactionSvc.getReceiveCurrency(CountryId).subscribe(
      (res) => {
        this.receiveCurrencyDropdown = res;
      }
    );
  }

  onSelectReceiveCurrency(ReceiveCurrencyID) {
    this.ReceiveCurrencyID = ReceiveCurrencyID;
  }

  getAgent(CountryId: any) {
    this.ApproveTransactionSvc.getAgent(0, CountryId).subscribe((res) => {
      this.AgentDropdown = res;
    });
  }

  onSelectAgent(AgentID) {
    this.AgentID = AgentID;
    this.getAgentBranch(AgentID);
    this.getTransferType(AgentID);
  }

  getAgentBranch(AgentID: any) {
    this.ApproveTransactionSvc.getAgentBranch(AgentID).subscribe((res) => {
      this.AgentBranchDropdown = res;
    });
  }

  onSelectAgentBranch(AgentBranchID) {
    this.AgentBranchID = AgentBranchID;
    this.getUser(AgentBranchID);
  }

  getUser(AgentBranchID) {
    this.ApproveTransactionSvc.getUser(this.AgentID, AgentBranchID).subscribe(
      (res) => {
        this.UserDropdown = res;
      }
    );
  }

  getTransferType(AgentID: any) {
    this.ApproveTransactionSvc.getTransferType(0, AgentID).subscribe((res) => {
      this.TransferTypeDropdown = res;
    });
  }

  onSelectTransferType(TransferTypeID) {
    this.TransferTypeID = TransferTypeID;
  }

  search() {
    if (this.selectedSearchOption == 1 && !this.transactionNumber) {
      alert('Please Enter Transaction No.');
      return;
    }
    if (this.selectedSearchOption == 1) {
      let payload = {
        SearchByType: 1,
        TrStatusID: -1,
        TrStatusList: [
          {
            Id: -1,
            Value: 'All',
          },
          {
            Id: 5,
            Value: 'AgentBlocked',
          },
          {
            Id: 7,
            Value: 'Cancellation request is pending or in process',
          },
          {
            Id: 4,
            Value: 'ComplianceBlock',
          },
          {
            Id: 8,
            Value: 'Hold',
          },
          {
            Id: 12,
            Value: 'Old',
          },
          {
            Id: 3,
            Value: 'Paid',
          },
          {
            Id: 2,
            Value: 'UnPaid',
          },
        ],
        PayOutCountryID: -1,
        PayOutCurrencyID: -1,
        TrTypeID: -1,
        TopRecord: 10,
        Transactions: 10,
        SRTRNo: this.transactionNumber,
        Agent_ID: 0,
        PayInCountryID: -1,
        PayInCurrencyID: -1,
        LoginAgentCountryID: 0,
        LoginAgentCityID: 0,
        LoginAgentLocationID: 0,
        G_Agent_ID: 0,
        AgentBranchId: 0,
        UserID: '-1',
      };
      this.ApproveTransactionSvc.AllRecord(payload).subscribe((res: any) => {
        if (res?.length == 0) {
          alert('No data found.');
          return;
        }
        this.allData = res;
      });
    }
    if (this.selectedSearchOption == 2) {
      let payload = {
        SearchByType: 2,
        TrStatusID: this.StatusID,
        TrStatusList: [
          {
            Id: -1,
            Value: 'All',
          },
          {
            Id: 5,
            Value: 'AgentBlocked',
          },
          {
            Id: 7,
            Value: 'Cancellation request is pending or in process',
          },
          {
            Id: 4,
            Value: 'ComplianceBlock',
          },
          {
            Id: 8,
            Value: 'Hold',
          },
          {
            Id: 12,
            Value: 'Old',
          },
          {
            Id: 3,
            Value: 'Paid',
          },
          {
            Id: 2,
            Value: 'UnPaid',
          },
        ],
        PayOutCountryID: this.ReceiveCountryID,
        PayOutCurrencyID: this.ReceiveCurrencyID,
        TrTypeID: -1,
        TopRecord: this.viewLastDropdown,
        Transactions: this.viewLastDropdown,
        SRTRNo: this.transactionNumber,
        Agent_ID: this.AgentID,
        PayInCountryID: this.payOutCountryID,
        PayInCurrencyID: this.sendCurrencyID,
        LoginAgentCountryID: 0,
        LoginAgentCityID: 0,
        LoginAgentLocationID: 0,
        G_Agent_ID: 0,
        AgentBranchId: this.AgentBranchID,
        StartDate: '',
        EndDate: '',
        UserID: '-1',
      };
      this.ApproveTransactionSvc.AllRecord(payload).subscribe((res: any) => {
        if (res?.length == 0) {
          alert('No data found.');
          return;
        }
        this.allData = res;
      });
    }
    if (this.selectedSearchOption == 3) {
      let payload = {
        SearchByType: 3,
        TrStatusID: -1,
        TrStatusList: [
          {
            Id: -1,
            Value: 'All',
          },
          {
            Id: 5,
            Value: 'AgentBlocked',
          },
          {
            Id: 7,
            Value: 'Cancellation request is pending or in process',
          },
          {
            Id: 4,
            Value: 'ComplianceBlock',
          },
          {
            Id: 8,
            Value: 'Hold',
          },
          {
            Id: 12,
            Value: 'Old',
          },
          {
            Id: 3,
            Value: 'Paid',
          },
          {
            Id: 2,
            Value: 'UnPaid',
          },
        ],
        PayOutCountryID: -1,
        PayOutCurrencyID: -1,
        TrTypeID: -1,
        TopRecord: 10,
        Transactions: 10,
        SRTRNo: '',
        Agent_ID: 0,
        Customer_Name_F: this.remitterFirstName,
        Customer_Name_L: this.remitterLastName,
        Beneficiary_Name_F: this.benefFirstName,
        Beneficiary_Name_L: this.benefLastName,
        PayInCountryID: -1,
        PayInCurrencyID: -1,
        StartDate: this.fromDate,
        EndDate: this.toDate,
        LoginAgentCountryID: 0,
        LoginAgentCityID: 0,
        LoginAgentLocationID: 0,
        G_Agent_ID: 0,
        AgentBranchId: 0,
        UserID: '-1',
      };
      this.ApproveTransactionSvc.AllRecord(payload).subscribe((res: any) => {
        if (res?.length == 0) {
          alert('No data found.');
          return;
        }
        this.allData = res;
      });
    }
  }

  openTransactionReceiptModal(template: TemplateRef<any>) {
    this.bsTransactionReceiptModalRef = this.modalService.show(template, {
      class: 'modal-lg',
    });
  }

  clearCriteria() {
    this.transactionNumber = '';
    this.fromDate = '';
    this.toDate = '';
    this.benefFirstName = '';
    this.benefLastName = '';
    this.remitterFirstName = '';
    this.remitterLastName = '';
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
}
