import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ManageAgencyUsersService {
  constructor(private http: HttpClient) {}

  getCountry() {
    return this.http.get(
      `${environment.apiUrl}/api/user-management/manage-agency-user/country`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getGroup(CountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/user-management/manage-agency-user/group?CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getUser(CountryID: any, GroupID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/user-management/manage-agency-user/user?CountryID=${CountryID}&GroupID=${GroupID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getDetails(UserNameID: string) {
    return this.http.get(
      `${environment.apiUrl}/api/user-management/manage-agency-user/get-detail?UserNameID=${UserNameID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAllRecord(GroupID: any, UserId: any) {
    return this.http.get(
      `${environment.apiUrl}/api/user-management/manage-agency-user/all-record?GroupID=${GroupID}&UserId=${UserId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  gridGroup(AgentID: any, UserGroup: any) {
    return this.http.get(
      `${environment.apiUrl}/api/user-management/manage-agency-user/grid-group?AgentID=${AgentID}&UserGroup=${UserGroup}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  subGridGroup(UserGroup: any) {
    return this.http.get(
      `${environment.apiUrl}/api/user-management/manage-agency-user/grid-sub-group?UserGroup=${UserGroup}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  addCountry(AgentTypeID: any = 1) {
    return this.http.get(
      `${environment.apiUrl}/api/user-management/manage-agency-user/add-country?AgentTypeID=${AgentTypeID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  addGroup(AgentTypeID: any = 1, CountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/user-management/manage-agency-user/add-group?AgentTypeID=${AgentTypeID}&CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  update(payload: any) {
    return this.http.patch(
      `${environment.apiUrl}/api/user-management/manage-agency-user/update`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  Delete(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/user-management/manage-agency-user/delete`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  addAgencyUser(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/user-management/manage-agency-user/add-agency-user`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  set(UserID: any, GroupID: any, SubGroupID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/user-management/manage-agency-user/set?UserID=${UserID}&GroupID=${GroupID}&SubGroupID=${SubGroupID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  setTree(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/user-management/manage-agency-user/set-tree`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
