import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class CountryWiseCurrencyRateService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getViewDailyRatesReport() {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/view-daily-rates-report/fill-grid`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
