import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class CtaHoldMarginService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getSendCountryList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/edit-cta-hold-margin/send-country`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getFillGrid(countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/edit-cta-hold-margin/grid?countryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCurrencyList(sendCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/edit-cta-hold-margin/sending-currency?_sendCountryID=${sendCountryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCountryList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/edit-cta-hold-margin/receive-country`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCurrencyList(receiveCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/edit-cta-hold-margin/receive-currency?_receiveCountryID=${receiveCountryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  addCTAHoldMargin(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/master/edit-cta-hold-margin/insert`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateCTAHoldMargin(payload: any = {}) {
    return this.http.patch(
      `${environment.apiUrl}/api/master/edit-cta-hold-margin/update`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
