import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class CustomerRegistrationService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getOccupationList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-customer-registration/occupation`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSourceList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-customer-registration/source`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getNationalityList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-customer-registration/nationality`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  addCustomerRegistration(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction-management/transaction-customer-registration/customer-registration`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  searchCustomer(iqamaNo: any = '') {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-customer-registration/search-customer?IqamaNo=${iqamaNo}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
