import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class DailyRatesService {
  url = environment.apiUrl;

  constructor(private router: Router, private http: HttpClient) {}

  getSendCountry(token: any, username, userId: any = 0, countryType: any = 0) {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/api/master/agent-wise-rate/daily-rates-sending-country?userId=${userId}&countryType=${countryType}`,
      {
        headers: headers,
      }
    );
  }

  getReceiveCountry(
    token: any,
    username,
    _CountryID: any = 0
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/api/master/agent-wise-rate/daily-rates-receiving-country?_CountryID=${_CountryID}&_MyType=1&_AsPerPermission=true
     `,
      {
        headers: headers,
      }
    );
  }

  getReceivingAgent(
    token: any,
    username,
    receivingCountryId: any = 0
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/api/master/agent-wise-rate/daily-rates-receiving-agent?receivingcountryId=${receivingCountryId}
     `,
      {
        headers: headers,
      }
    );
  }

  getSendingAgent(
    token: any,
    username,
    sendingCountryId: any = 0
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/api/master/agent-wise-rate/daily-rates-sending-agent?sendingcountryId=${sendingCountryId}
     `,
      {
        headers: headers,
      }
    );
  }

  getCIFNumbers(token: any, username): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/api/master/agent-wise-rate/daily-rates-cif-number-list
     `,
      {
        headers: headers,
      }
    );
  }

  getAllDailyRates(token: any, username, payload): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.post(
      `${environment.apiUrl}/api/master/agent-wise-rate/daily-rates-fill-gridview
     `,
      payload,
      {
        headers: headers,
      }
    );
  }
}
