import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';
import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root',
})
export class MgTransactionAccountDetailsService {
  baseUrl = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getTransactionDetailsByCountry(userId: any): Observable<any> {
    return this.http.get(
      `${this.baseUrl}/api/master/reports/mg-transaction-details-report/country?G_UserID=${userId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getTransactionDetailsByAgent(countryId: any): Observable<any> {
    return this.http.get(
      `${this.baseUrl}/api/master/reports/mg-transaction-details-report/agent?CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getTransactionDetailsGrid(FromDate: any,ToDate:any,CountryID:any,AgentID:any,CustomerType:any,TransactionNumber:any,ByTxn:any): Observable<any> {
    const transactionNumberParam = TransactionNumber ? TransactionNumber : '';

    return this.http.get(
      `${this.baseUrl}/api/master/reports/mg-transaction-details-report/grid?FromDate=${FromDate}&ToDate=${ToDate}&CountryID=${CountryID}&AgentID=${AgentID}&CustomerType=${CustomerType}&TransactionNumber=${transactionNumberParam}&ByTxn=${ByTxn}`,
     
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getlogGrid(TransactionNumber:any,): Observable<any> {
 
 
    return this.http.get(
      `${this.baseUrl}/api/transaction/cancellation-checker/log?TransactionNumber=${TransactionNumber}`,
     
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
