import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root'
})
export class RatesInSummarizedWayService {

  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getCountryData(userId: any ) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/rpt-rates-insummarized-wayreport-country/country?G_UserID=${userId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendAgentData(countryId: any ) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/rpt-rates-insummarized-wayreport-country/send-agent?CountryID=${countryId}&permissionType=2&AsPerPermission=true`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCountryData(countryId: any  ) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/rpt-rates-insummarized-wayreport-country/receive-country?AsPerPermission=true&_CountryID=${countryId}&permissionType=1`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveAgentData(countryId: any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/rpt-rates-insummarized-wayreport-country/receive-agent?CountryID=${countryId}&permissionType=1`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  SummarizedWayReportCountry(requestBody: any) {
    return this.http.post(
      `${environment.apiUrl}/api/master/reports/rpt-rates-insummarized-wayreport-country/grid?gridRequest=1&permissionType=2`,
      requestBody,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
