import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';
import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root',
})
export class RegisteredCustommersDetailsService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getTypeList(): Observable<any> {
    return this.http.get(
      `${this.url}/api/master/reports/customer-report/type-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getFillGrid(
    reportType: any,
    typeOfCustomer: any,
    fromDate: any,
    toDate: any
  ): Observable<any> {
    return this.http.get(
      `${this.url}/api/master/reports/customer-report/fill-grid?ReportType=${reportType}&TypeofCustomer=${typeOfCustomer}&FromDate=${fromDate}&ToDate=${toDate}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
