import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class RepushTransactionsService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getRepushTransactionReport(fromDate: any, toDate: any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/rpt-repush-transaction-report/fill-grid?FromDate=${fromDate}&ToDate=${toDate}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  Transactionreport(TransactionNumber:any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-cancel-paid/transaction-report?TransactionNumber=${TransactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
