import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class TransactionAccountingDetailsService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getCountryList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/transaction-details-report/country-list?userID=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentListByCountry(countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/transaction-details-report/agent-list?CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getFillGrid(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/master/reports/transaction-details-report/fill-grid`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getTransactionDetails(transactionNumber: string) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/transaction-details-report/view-account?TransactionNumber=${transactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
